<?php
/**
#	Project: PHPDISK File Storage Solution
#	This is NOT a freeware, use is subject to license terms.
#
#	Site: http://www.phpdisk.com
#
#	$Id: admin.inc.php 3 2011-12-19 08:46:16Z along $
#
#	Copyright (C) 2008-2013 PHPDisk Team. All Rights Reserved.
#
*/
if(!defined('IN_DISCUZ') || !defined('IN_ADMINCP')) {
	exit('[PHPDISK] Access Denied');
}
require 'includes/commons.inc.php';

$pmod = 'adm_nodes';

$q = DB::query("select subject,node_id from ".DB::table('phpdisk_nodes')." where parent_id=0 order by show_order asc,node_id asc");
$nd = array();
while ($rs = DB::fetch($q)) {
	$nd[] = $rs;
}
unset($rs);

showtableheader();
switch ($act){
	case 'add':
		if($task =='add'){
			form_auth(gpc('formhash','P',''),formhash());
			$subject = trim(gpc('subject','P',''));
			$server_oid = trim(gpc('server_oid','P',''));
			$host = trim(gpc('host','P',''));
			$icon = trim(gpc('icon','P',''));
			$down_type = (int)gpc('down_type','P',0);
			$parent_id = (int)gpc('parent_id','P',0);
			$is_hidden = (int)gpc('is_hidden','P',0);

			if(checklength($subject,1,250)){
				$error = true;
				$sysmsg[] = '节点标题不能为空，长度为1-100字符以内';
			}else{
				$num = DB::result_first("select count(*) from ".DB::table('phpdisk_nodes')." where subject='$subject'");
				if($num){
					$error = true;
					$sysmsg[] = '节点标题已存在，请返回修改';
				}
			}
			if($parent_id && !$host){
				$error = true;
				$sysmsg[] = '节点主机不能为空';
			}
			if($parent_id && (substr($host,0,7)!='http://' && substr($host,0,8)!='https://')){
				$error = true;
				$sysmsg[] = '节点主机格式有误，需要以 http:// 或 https:// 开头，以 / 结束';
			}elseif($parent_id && substr($host,-1)!='/'){
				$error = true;
				$sysmsg[] = '节点主机格式有误，需要以 http:// 或 https:// 开头，以 / 结束';
			}

			if(!$error){
				$ins = array(
				'subject'=>$subject,
				'host'=>$parent_id ? $host : '-',
				'server_oid'=>$server_oid,
				'icon'=>$icon,
				'down_type'=>$down_type,
				'parent_id'=>$parent_id,
				'is_hidden'=>$is_hidden,
				);
				DB::query("insert into ".DB::table('phpdisk_nodes')." set ".sql_array($ins)."");

				admincp_msg('下载节点添加成功。',"admin.php?action=plugins&operation=config&do=$pluginid&identifier=phpdisk&pmod=$pmod");
			}else{
				admincp_msg($sysmsg,"admin.php?action=plugins&operation=config&do=$pluginid&identifier=phpdisk&pmod=$pmod",0);
			}
		}else{
			$pa = array();
			$pa[is_hidden] = 0;
			$pa[down_type] = 0;
			require_once(PHPDISK_ROOT.'template/admin/'.$pmod.'.tpl.php');
		}
		break;
	case 'edit':
		$node_id = (int)gpc('node_id','GP',0);
		if($task=='edit'){
			form_auth(gpc('formhash','P',''),formhash());
			$subject = trim(gpc('subject','P',''));
			$host = trim(gpc('host','P',''));
			$server_oid = trim(gpc('server_oid','P',''));
			$icon = trim(gpc('icon','P',''));
			$down_type = (int)gpc('down_type','P',0);
			$parent_id = (int)gpc('parent_id','P',0);
			$is_hidden = (int)gpc('is_hidden','P',0);

			if(checklength($subject,1,150)){
				$error = true;
				$sysmsg[] = '节点标题不能为空，长度为1-100字符以内';
			}else{
				$num = DB::result_first("select count(*) from ".DB::table('phpdisk_nodes')." where subject='$subject' and node_id<>'$node_id'");
				if($num){
					$error = true;
					$sysmsg[] = '节点标题已存在，请返回修改';
				}
			}
			if($parent_id && !$host){
				$error = true;
				$sysmsg[] = '节点主机不能为空';
			}
			if($parent_id && (substr($host,0,7)!='http://' && substr($host,0,8)!='https://')){
				$error = true;
				$sysmsg[] = '节点主机格式有误，需要以 http:// 或 https:// 开头，以 / 结束';
			}elseif($parent_id && substr($host,-1)!='/'){
				$error = true;
				$sysmsg[] = '节点主机格式有误，需要以 http:// 或 https:// 开头，以 / 结束';
			}
			if($parent_id==$node_id){
				$error = true;
				$sysmsg[] = '不能把自己设置为父节点';
			}

			if(!$error){
				$ins = array(
				'subject'=>$subject,
				'host'=>$parent_id ? $host : '-',
				'server_oid'=>$server_oid,
				'icon'=>$icon,
				'down_type'=>$down_type,
				'parent_id'=>$parent_id,
				'is_hidden'=>$is_hidden,
				);
				DB::query("update ".DB::table('phpdisk_nodes')." set ".sql_array($ins)." where node_id='$node_id'");
				admincp_msg('下载节点编辑成功。',"admin.php?action=plugins&operation=config&do=$pluginid&identifier=phpdisk&pmod=$pmod");
			}else{
				admincp_msg($sysmsg,"admin.php?action=plugins&operation=config&do=$pluginid&identifier=phpdisk&pmod=$pmod",0);
			}
		}else{
			$sv = DB::fetch_first("select * from ".DB::table('phpdisk_nodes')." where node_id='$node_id'");
			require_once(PHPDISK_ROOT.'template/admin/'.$pmod.'.tpl.php');
		}
		break;
	case 'del':
		$node_id = (int)gpc('node_id','G',0);
		if($node_id){
			DB::query("delete from ".DB::table('phpdisk_nodes')." where node_id='$node_id' or parent_id='$node_id'");
			admincp_msg('下载节点删除成功',"admin.php?action=plugins&operation=config&do=$pluginid&identifier=phpdisk&pmod=$pmod");
		}else{
			admincp_msg('下载节点删除失败',"admin.php?action=plugins&operation=config&do=$pluginid&identifier=phpdisk&pmod=$pmod",0);
		}
		break;
	case 'change_status':
		$node_id = (int)gpc('node_id','G',0);
		if($node_id){
			$is_hidden = (int)DB::result_first("select is_hidden from ".DB::table('phpdisk_nodes')." where node_id='$node_id'");
			$is_hidden = $is_hidden ? 0 : 1;
			DB::query("update ".DB::table('phpdisk_nodes')." set is_hidden='$is_hidden' where node_id='$node_id'");
			admincp_msg('下载节点状态更新成功',"admin.php?action=plugins&operation=config&do=$pluginid&identifier=phpdisk&pmod=$pmod");
		}else{
			admincp_msg('下载节点状态更新失败',"admin.php?action=plugins&operation=config&do=$pluginid&identifier=phpdisk&pmod=$pmod",0);
		}
		break;
	case 'update_host':
		$q = DB::query("select server_oid,node_id from ".DB::table('phpdisk_nodes')." where parent_id>0");
		$nodes = array();
		while ($rs = DB::fetch($q)) {
			$rs2 = DB::fetch_first("select server_host from ".DB::table('phpdisk_servers')." where server_oid='{$rs[server_oid]}'");
			DB::query("update ".DB::table('phpdisk_nodes')." set host='{$rs2[server_host]}' where node_id='{$rs[node_id]}'");
		}
		unset($rs);
		admincp_msg('下载节点主机地址更新成功',"admin.php?action=plugins&operation=config&do=$pluginid&identifier=phpdisk&pmod=$pmod");
		break;
	default:
		$q = DB::query("select * from ".DB::table('phpdisk_nodes')." order by show_order asc,node_id asc");
		$nodes = array();
		while ($rs = DB::fetch($q)) {
			$rs[icon] = $rs[icon] ? '<img src="'.$rs[icon].'" align="absmiddle" border="0" />' : '&nbsp;';
			$rs['status_text'] = $rs['is_hidden'] ? '<span  style="color:#FF0000">隐藏</span>' : '<span  style="color:#0000FF">显示</span>';
			$rs['a_change_status'] = 'admin.php?action=plugins&operation=config&do='.$pluginid.'&identifier=phpdisk&pmod='.$pmod.'&act=change_status&node_id='.$rs[node_id];
			$rs['a_edit_node'] = 'admin.php?action=plugins&operation=config&do='.$pluginid.'&identifier=phpdisk&pmod='.$pmod.'&act=edit&node_id='.$rs[node_id];
			$rs['a_del_node'] = 'admin.php?action=plugins&operation=config&do='.$pluginid.'&identifier=phpdisk&pmod='.$pmod.'&act=del&node_id='.$rs[node_id];
			$nodes[] = $rs;
		}
		unset($rs);
		require_once(PHPDISK_ROOT.'template/admin/'.$pmod.'.tpl.php');
}
showtablefooter();

?>