<?php
/**
#	Project: PHPDISK File Storage Solution
#	This is NOT a freeware, use is subject to license terms.
#
#	Site: http://www.phpdisk.com
#
#	$Id: admin.inc.php 3 2011-12-19 08:46:16Z along $
#
#	Copyright (C) 2008-2013 PHPDisk Team. All Rights Reserved.
#
*/
if(!defined('IN_DISCUZ') || !defined('IN_ADMINCP')) {
	exit('[PHPDISK] Access Denied');
}
require 'includes/commons.inc.php';

$pmod = 'adm_servers';
$action_url = "admin.php?action=plugins&operation=config&do=$pluginid&identifier=phpdisk&pmod=$pmod";
showtableheader();
switch($act){
	case 'add':
		if($task=='add'){

			form_auth(gpc('formhash','P',''),formhash());

			$server_name = trim(gpc('server_name','P',''));
			$server_oid = (int)gpc('server_oid','P',0);
			$server_host = trim(gpc('server_host','P',''));
			$server_dl_host = trim(gpc('server_dl_host','P',''));
			$server_key = trim(gpc('server_key','P',''));
			$server_store_path = trim(gpc('server_store_path','P',''));

			if(checklength($server_name,1,100)){
				$error = true;
				$sysmsg[] = '服务器名称不能为空，请重新填写';
			}
			if(!is_numeric($server_oid)){
				$error = true;
				$sysmsg[] = '服务器ID标识只能为整数。';
			}elseif((int)$server_oid==1){
				$error = true;
				$sysmsg[] = '服务器ID必需大于1';
			}
			$num = (int)DB::result_first("select count(*) from ".DB::table('phpdisk_servers')." where server_oid='$server_oid'");
			if($num){
				$error = true;
				$sysmsg[] = '服务器ID标识已存在，请重新修改。';
			}
			if(substr($server_host,0,7) !='http://' && substr($server_host,0,8) !='https://'){
				$error = true;
				$sysmsg[] = '服务器地址不能为空，请以 http:// 或 https:// 开头的服务器地址';
			}else{
				$server_host = substr($server_host,-1) =='/' ? $server_host : $server_host.'/';
			}
			if(!$server_key){
				$error = true;
				$sysmsg[] = '请填写子服通信密钥。';
			}else{
				$num = (int)DB::result_first("select count(*) from ".DB::table('phpdisk_servers')." where server_key='$server_key'");
				if($num){
					$error = true;
					$sysmsg[] = '子服密钥已存在，请返回修改';
				}
			}
			if(!$server_store_path){
				$error = true;
				$sysmsg[] = '请填写子服文件存储目录。';
			}

			$num = (int)DB::result_first("select count(*) from ".DB::table('phpdisk_servers')." where server_host='$server_host'");
			if($num){
				$error = true;
				$sysmsg[] = '此服务器已存在，请重新填写';
			}
			unset($rs);
			if($server_dl_host && strpos($server_dl_host,'http')===false){
				$error = true;
				$sysmsg[] = '下载服务器配置格式错误，请看左侧说明再行配置。';
			}
			if(!$error){
				$ins = array(
				'server_name' => $server_name,
				'server_oid' => $server_oid,
				'server_host' => $server_host,
				'server_dl_host' => $server_dl_host,
				'server_closed' => $server_closed,
				'server_key' => $server_key,
				'server_store_path' => $server_store_path,
				);
				DB::query("insert into ".DB::table('phpdisk_servers')." set ".sql_array($ins).";");

				admincp_msg('分布服务器添加成功。',"admin.php?action=plugins&operation=config&do=$pluginid&identifier=phpdisk&pmod=$pmod");
			}else{
				admincp_msg($sysmsg,"admin.php?action=plugins&operation=config&do=$pluginid&identifier=phpdisk&pmod=$pmod",0);
			}
		}else{
			$server_oid = (int)DB::result_first("select server_id from ".DB::table('phpdisk_servers')." order by server_id desc limit 1");
			$sv[server_oid] = $server_oid ? ($server_oid+1) : 2;
			$sv[server_key] = random(12);
			$sv[server_store_path] = $settings['file_path'];
			require_once(PHPDISK_ROOT.'template/admin/'.$pmod.'.tpl.php');
		}
		break;
	case 'edit':
		$server_id = (int)gpc('server_id','GP',0);
		if($task=='edit'){
			form_auth(gpc('formhash','P',''),formhash());

			$server_name = trim(gpc('server_name','P',''));
			$server_oid = (int)gpc('server_oid','P',0);
			$server_host = trim(gpc('server_host','P',''));
			$server_dl_host = trim(gpc('server_dl_host','P',''));
			$server_key = trim(gpc('server_key','P',''));
			$server_store_path = trim(gpc('server_store_path','P',''));

			if(checklength($server_name,1,100)){
				$error = true;
				$sysmsg[] = '服务器名称不能为空，请重新填写';
			}
			if(!is_numeric($server_oid)){
				$error = true;
				$sysmsg[] = '服务器ID标识只能为整数。';
			}elseif((int)$server_oid==1){
				$error = true;
				$sysmsg[] = '服务器ID必需大于1';
			}
			$num = DB::result_first("select count(*) from ".DB::table('phpdisk_servers')." where server_oid='$server_oid' and server_id<>'$server_id'");
			if($num){
				$error = true;
				$sysmsg[] = '服务器ID标识已存在，请重新修改。';
			}
			if(substr($server_host,0,7) !='http://' && substr($server_host,0,8) !='https://'){
				$error = true;
				$sysmsg[] = '服务器地址不能为空，请以 http:// 或 https:// 开头的服务器地址';
			}else{
				$server_host = substr($server_host,-1) =='/' ? $server_host : $server_host.'/';
			}
			if(!$server_key){
				$error = true;
				$sysmsg[] = '请填写子服通信密钥。';
			}else{
				$num = DB::result_first("select count(*) from ".DB::table('phpdisk_servers')." where server_key='$server_key' and server_id<>'$server_id'");
				if($num){
					$error = true;
					$sysmsg[] = '子服密钥已存在，请返回修改';
				}
			}

			$num = DB::result_first("select count(*) as total from ".DB::table('phpdisk_servers')." where server_host='$server_host' and server_id<>'$server_id'");
			if($num){
				$error = true;
				$sysmsg[] = '此服务器已存在，请重新填写';
			}
			unset($rs);
			if($server_dl_host && strpos($server_dl_host,'http')===false){
				$error = true;
				$sysmsg[] = '下载服务器配置格式错误，请看左侧说明再行配置。';
			}
			if(!$error){
				$ooid = (int)DB::result_first("select server_oid from ".DB::table('phpdisk_servers')." where server_id='$server_id'");
				DB::query("update ".DB::table('phpdisk_files')." set server_oid='$server_oid' where server_oid='$ooid'");
				$ins = array(
				'server_name' => $server_name,
				'server_oid' => $server_oid,
				'server_host' => $server_host,
				'server_dl_host' => $server_dl_host,
				'server_closed' => $server_closed,
				'server_key' => $server_key,
				'server_store_path' => $server_store_path,
				);
				DB::query("update ".DB::table('phpdisk_servers')." set ".sql_array($ins)." where server_id='$server_id';");

				admincp_msg('分布服务器编辑成功。',"admin.php?action=plugins&operation=config&do=$pluginid&identifier=phpdisk&pmod=$pmod");
			}else{
				admincp_msg($sysmsg,"admin.php?action=plugins&operation=config&do=$pluginid&identifier=phpdisk&pmod=$pmod",0);
			}
		}else{
			if($server_id){
				$sv = DB::fetch_first("select * from ".DB::table('phpdisk_servers')." where server_id='$server_id'");
			}
			require_once(PHPDISK_ROOT.'template/admin/'.$pmod.'.tpl.php');
		}
		break;
	case 'del':
		$server_id = (int)gpc('server_id','G',0);
		if($server_id){
			$num = (int)DB::result_first("select count(*) from ".DB::table('phpdisk_files')." where server_oid=(select server_oid from ".DB::table('phpdisk_servers')." where server_id='$server_id')");
			if($num){
				admincp_msg('分布服务器删除失败，此文件服务器下存在文件，请将相应的文件移动到别的服务器下才进行删除操作。',"admin.php?action=plugins&operation=config&do=$pluginid&identifier=phpdisk&pmod=$pmod",0);
			}else{
				DB::query("delete from ".DB::table('phpdisk_servers')." where server_id='$server_id'");
				admincp_msg('分布服务器删除成功',"admin.php?action=plugins&operation=config&do=$pluginid&identifier=phpdisk&pmod=$pmod");
			}
		}else{
			admincp_msg('分布服务器删除失败',"admin.php?action=plugins&operation=config&do=$pluginid&identifier=phpdisk&pmod=$pmod",0);
		}
		break;
	case 'set_default':
		$server_id = (int)gpc('server_id','G',0);
		if($server_id){
			DB::query("update ".DB::table('phpdisk_servers')." set is_default=0");
			DB::query("update ".DB::table('phpdisk_servers')." set is_default=9 where server_id=1");
			DB::query("update ".DB::table('phpdisk_servers')." set is_default=1 where server_id='$server_id'");
			admincp_msg('分布服务器设置默认成功',"admin.php?action=plugins&operation=config&do=$pluginid&identifier=phpdisk&pmod=$pmod");
		}else{
			admincp_msg('分布服务器设置默认失败',"admin.php?action=plugins&operation=config&do=$pluginid&identifier=phpdisk&pmod=$pmod",0);
		}
		break;
	default:
		if($task=='update'){
			form_auth(gpc('formhash','P',''),formhash());
			$set = array(
			'open_multi_server' => 0,
			);
			$sets = gpc('set','P',$set);

			if(!$error){
				settings_cache($sets);

				admincp_msg('分布服务器设置更新成功。',"admin.php?action=plugins&operation=config&do=$pluginid&identifier=phpdisk&pmod=$pmod");
			}else{
				admincp_msg('分布服务器设置更新失败。',"admin.php?action=plugins&operation=config&do=$pluginid&identifier=phpdisk&pmod=$pmod",0);
			}
		}else{
			$q = DB::query("select * from ".DB::table('phpdisk_servers')." order by is_default desc,server_id asc");
			while ($rs = DB::fetch($q)) {
				$rt = DB::fetch_first("select sum(file_size) as total from ".DB::table('phpdisk_files')." where server_oid='{$rs[server_oid]}'");
				$rs[server_size] = get_size($rt[total]);
				$rs[a_edit] = 'admin.php?action=plugins&operation=config&do='.$pluginid.'&identifier=phpdisk&pmod='.$pmod.'&act=edit&server_id='.$rs[server_id];
				$rs[a_del] = 'admin.php?action=plugins&operation=config&do='.$pluginid.'&identifier=phpdisk&pmod='.$pmod.'&act=del&server_id='.$rs[server_id];
				$rs[a_set_default] = 'admin.php?action=plugins&operation=config&do='.$pluginid.'&identifier=phpdisk&pmod='.$pmod.'&act=set_default&server_id='.$rs[server_id];
				$rs[is_default] = $rs[is_default]==1 ? '<span style="color:#008800">(当前上传)</span>' : '';
				$servers[] = $rs;
			}
			unset($rs);
			require_once(PHPDISK_ROOT.'template/admin/'.$pmod.'.tpl.php');
		}
}


showtablefooter();
//}
?>